Index: /palm/trunk/SOURCE/diffusion_s.f90
===================================================================
--- /palm/trunk/SOURCE/diffusion_s.f90	(revision 2231)
+++ /palm/trunk/SOURCE/diffusion_s.f90	(revision 2232)
@@ -274,84 +492,232 @@
 !
 !--    Compute horizontal diffusion
-       DO  k = nzb_s_outer(j,i)+1, nzt
+       DO  k = nzb+1, nzt
+!
+!--       Predetermine flag to mask topography and wall-bounded grid points
+          flag = MERGE( 1.0_wp, 0.0_wp, BTEST( wall_flags_0(k,j,i), 0 ) ) 
+!
+!--       Predetermine flag to mask wall-bounded grid points, equivalent to
+!--       former s_outer array
+          mask_west  = MERGE( 1.0_wp, 0.0_wp, BTEST( wall_flags_0(k,j,i-1), 0 ) )
+          mask_east  = MERGE( 1.0_wp, 0.0_wp, BTEST( wall_flags_0(k,j,i+1), 0 ) )
+          mask_south = MERGE( 1.0_wp, 0.0_wp, BTEST( wall_flags_0(k,j-1,i), 0 ) )
+          mask_north = MERGE( 1.0_wp, 0.0_wp, BTEST( wall_flags_0(k,j+1,i), 0 ) )
+!
+!--       Finally, determine flag to mask both topography itself as well
+!--       as wall-bounded grid points, which will be treated further below
 
           tend(k,j,i) = tend(k,j,i)                                            &
                                           + 0.5_wp * (                         &
-                        ( kh(k,j,i) + kh(k,j,i+1) ) * ( s(k,j,i+1)-s(k,j,i) )  &
-                      - ( kh(k,j,i) + kh(k,j,i-1) ) * ( s(k,j,i)-s(k,j,i-1) )  &
-                                                     ) * ddx2                  &
+                            mask_east  * ( kh(k,j,i) + kh(k,j,i+1) )           &
+                                       * ( s(k,j,i+1) - s(k,j,i)   )           &
+                          - mask_west  * ( kh(k,j,i) + kh(k,j,i-1) )           &
+                                       * ( s(k,j,i)   - s(k,j,i-1) )           &
+                                                     ) * ddx2 * flag           &
                                           + 0.5_wp * (                         &
-                        ( kh(k,j,i) + kh(k,j+1,i) ) * ( s(k,j+1,i)-s(k,j,i) )  &
-                      - ( kh(k,j,i) + kh(k,j-1,i) ) * ( s(k,j,i)-s(k,j-1,i) )  &
-                                                     ) * ddy2
-       ENDDO
-
-!
-!--    Apply prescribed horizontal wall heatflux where necessary
-       IF ( ( wall_w_x(j,i) /= 0.0_wp ) .OR. ( wall_w_y(j,i) /= 0.0_wp ) )     &
-       THEN
-          DO  k = nzb_s_inner(j,i)+1, nzb_s_outer(j,i)
-
-             tend(k,j,i) = tend(k,j,i)                                         &
-                                                + ( fwxp(j,i) * 0.5_wp *       &
-                        ( kh(k,j,i) + kh(k,j,i+1) ) * ( s(k,j,i+1)-s(k,j,i) )  &
-                        + ( 1.0_wp - fwxp(j,i) ) * wall_s_flux(1)              &
-                                                   -fwxm(j,i) * 0.5_wp *       &
-                        ( kh(k,j,i) + kh(k,j,i-1) ) * ( s(k,j,i)-s(k,j,i-1) )  &
-                        + ( 1.0_wp - fwxm(j,i) ) * wall_s_flux(2)              &
-                                                  ) * ddx2                     &
-                                                + ( fwyp(j,i) * 0.5_wp *       &
-                        ( kh(k,j,i) + kh(k,j+1,i) ) * ( s(k,j+1,i)-s(k,j,i) )  &
-                        + ( 1.0_wp - fwyp(j,i) ) * wall_s_flux(3)              &
-                                                   -fwym(j,i) * 0.5_wp *       &
-                        ( kh(k,j,i) + kh(k,j-1,i) ) * ( s(k,j,i)-s(k,j-1,i) )  &
-                        + ( 1.0_wp - fwym(j,i) ) * wall_s_flux(4)              &
-                                                  ) * ddy2
+                            mask_north * ( kh(k,j,i) + kh(k,j+1,i) )           &
+                                       * ( s(k,j+1,i) - s(k,j,i)   )           &
+                          - mask_south * ( kh(k,j,i) + kh(k,j-1,i) )           &
+                                       * ( s(k,j,i)  - s(k,j-1,i)  )           &
+                                                     ) * ddy2 * flag
+       ENDDO
+
+!
+!--    Apply prescribed horizontal wall heatflux where necessary. First,
+!--    determine start and end index for respective (j,i)-index. Please
+!--    note, in the flat case following loops will not be entered, as
+!--    surf_s=1 and surf_e=0. Furtermore, note, no vertical natural surfaces
+!--    so far. 
+!--    First, for default-type surfaces
+!--    North-facing vertical default-type surfaces
+       surf_s = surf_def_v(0)%start_index(j,i)
+       surf_e = surf_def_v(0)%end_index(j,i)
+       DO  m = surf_s, surf_e
+          k           = surf_def_v(0)%k(m)
+          tend(k,j,i) = tend(k,j,i) + s_flux_def_v_north(m) * ddy2
+       ENDDO
+!
+!--    South-facing vertical default-type surfaces
+       surf_s = surf_def_v(1)%start_index(j,i)
+       surf_e = surf_def_v(1)%end_index(j,i)
+       DO  m = surf_s, surf_e
+          k           = surf_def_v(1)%k(m)
+          tend(k,j,i) = tend(k,j,i) + s_flux_def_v_south(m) * ddy2
+       ENDDO
+!
+!--    East-facing vertical default-type surfaces
+       surf_s = surf_def_v(2)%start_index(j,i)
+       surf_e = surf_def_v(2)%end_index(j,i)
+       DO  m = surf_s, surf_e
+          k           = surf_def_v(2)%k(m)
+          tend(k,j,i) = tend(k,j,i) + s_flux_def_v_east(m) * ddx2
+       ENDDO
+!
+!--    West-facing vertical default-type surfaces
+       surf_s = surf_def_v(3)%start_index(j,i)
+       surf_e = surf_def_v(3)%end_index(j,i)
+       DO  m = surf_s, surf_e
+          k           = surf_def_v(3)%k(m)
+          tend(k,j,i) = tend(k,j,i) + s_flux_def_v_west(m) * ddx2
+       ENDDO
+!
+!--    Now, for natural-type surfaces
+!--    North-facing
+       surf_s = surf_lsm_v(0)%start_index(j,i)
+       surf_e = surf_lsm_v(0)%end_index(j,i)
+       DO  m = surf_s, surf_e
+          k           = surf_lsm_v(0)%k(m)
+          tend(k,j,i) = tend(k,j,i) + s_flux_lsm_v_north(m) * ddy2
+       ENDDO
+!
+!--    South-facing
+       surf_s = surf_lsm_v(1)%start_index(j,i)
+       surf_e = surf_lsm_v(1)%end_index(j,i)
+       DO  m = surf_s, surf_e
+          k           = surf_lsm_v(1)%k(m)
+          tend(k,j,i) = tend(k,j,i) + s_flux_lsm_v_south(m) * ddy2
+       ENDDO
+!
+!--    East-facing
+       surf_s = surf_lsm_v(2)%start_index(j,i)
+       surf_e = surf_lsm_v(2)%end_index(j,i)
+       DO  m = surf_s, surf_e
+          k           = surf_lsm_v(2)%k(m)
+          tend(k,j,i) = tend(k,j,i) + s_flux_lsm_v_east(m) * ddx2
+       ENDDO
+!
+!--    West-facing
+       surf_s = surf_lsm_v(3)%start_index(j,i)
+       surf_e = surf_lsm_v(3)%end_index(j,i)
+       DO  m = surf_s, surf_e
+          k           = surf_lsm_v(3)%k(m)
+          tend(k,j,i) = tend(k,j,i) + s_flux_lsm_v_west(m) * ddx2
+       ENDDO
+!
+!--    Now, for urban-type surfaces
+!--    North-facing
+       surf_s = surf_usm_v(0)%start_index(j,i)
+       surf_e = surf_usm_v(0)%end_index(j,i)
+       DO  m = surf_s, surf_e
+          k           = surf_usm_v(0)%k(m)
+          tend(k,j,i) = tend(k,j,i) + s_flux_usm_v_north(m) * ddy2
+       ENDDO
+!
+!--    South-facing
+       surf_s = surf_usm_v(1)%start_index(j,i)
+       surf_e = surf_usm_v(1)%end_index(j,i)
+       DO  m = surf_s, surf_e
+          k           = surf_usm_v(1)%k(m)
+          tend(k,j,i) = tend(k,j,i) + s_flux_usm_v_south(m) * ddy2
+       ENDDO
+!
+!--    East-facing
+       surf_s = surf_usm_v(2)%start_index(j,i)
+       surf_e = surf_usm_v(2)%end_index(j,i)
+       DO  m = surf_s, surf_e
+          k           = surf_usm_v(2)%k(m)
+          tend(k,j,i) = tend(k,j,i) + s_flux_usm_v_east(m) * ddx2
+       ENDDO
+!
+!--    West-facing
+       surf_s = surf_usm_v(3)%start_index(j,i)
+       surf_e = surf_usm_v(3)%end_index(j,i)
+       DO  m = surf_s, surf_e
+          k           = surf_usm_v(3)%k(m)
+          tend(k,j,i) = tend(k,j,i) + s_flux_usm_v_west(m) * ddx2
+       ENDDO
+
+
+!
+!--    Compute vertical diffusion. In case that surface fluxes have been
+!--    prescribed or computed at bottom and/or top, index k starts/ends at
+!--    nzb+2 or nzt-1, respectively. Model top is also mask if top flux 
+!--    is given. 
+       DO  k = nzb+1, nzt
+!
+!--       Determine flags to mask topography below and above. Flag 0 is 
+!--       used to mask topography in general, and flag 8 implies 
+!--       information about use_surface_fluxes. Flag 9 is used to control 
+!--       flux at model top.   
+          mask_bottom = MERGE( 1.0_wp, 0.0_wp,                                 &
+                               BTEST( wall_flags_0(k-1,j,i), 8 ) ) 
+          mask_top    = MERGE( 1.0_wp, 0.0_wp,                                 &
+                               BTEST( wall_flags_0(k+1,j,i), 8 ) )  *          &
+                        MERGE( 1.0_wp, 0.0_wp,                                 &
+                               BTEST( wall_flags_0(k+1,j,i), 9 ) )
+          flag        = MERGE( 1.0_wp, 0.0_wp,                                 &
+                               BTEST( wall_flags_0(k,j,i), 0 ) )
+
+          tend(k,j,i) = tend(k,j,i)                                            &
+                                       + 0.5_wp * (                            &
+                                      ( kh(k,j,i) + kh(k+1,j,i) ) *            &
+                                          ( s(k+1,j,i)-s(k,j,i) ) * ddzu(k+1)  &
+                                                            * rho_air_zw(k)    &
+                                                            * mask_top         &
+                                    - ( kh(k,j,i) + kh(k-1,j,i) ) *            &
+                                          ( s(k,j,i)-s(k-1,j,i) ) * ddzu(k)    &
+                                                            * rho_air_zw(k-1)  &
+                                                            * mask_bottom      &
+                                                  ) * ddzw(k) * drho_air(k)    &
+                                                              * flag
+       ENDDO
+
+!
+!--    Vertical diffusion at horizontal walls.
+!--    TO DO: Adjust for downward facing walls and mask already in main loop
+       IF ( use_surface_fluxes )  THEN
+!
+!--       Default-type surfaces, upward-facing
+          surf_s = surf_def_h(0)%start_index(j,i)
+          surf_e = surf_def_h(0)%end_index(j,i)
+          DO  m = surf_s, surf_e
+
+             k   = surf_def_h(0)%k(m)
+
+             tend(k,j,i) = tend(k,j,i) + s_flux_def_h_up(m)                    &
+                                       * ddzw(k) * drho_air(k)
+          ENDDO
+!
+!--       Default-type surfaces, downward-facing
+          surf_s = surf_def_h(1)%start_index(j,i)
+          surf_e = surf_def_h(1)%end_index(j,i)
+          DO  m = surf_s, surf_e
+
+             k   = surf_def_h(1)%k(m)
+
+             tend(k,j,i) = tend(k,j,i) + s_flux_def_h_down(m)                  &
+                                       * ddzw(k) * drho_air(k)
+          ENDDO
+!
+!--       Natural-type surfaces, upward-facing
+          surf_s = surf_lsm_h%start_index(j,i)
+          surf_e = surf_lsm_h%end_index(j,i)
+          DO  m = surf_s, surf_e
+             k   = surf_lsm_h%k(m)
+
+             tend(k,j,i) = tend(k,j,i) + s_flux_lsm_h_up(m)                    &
+                                       * ddzw(k) * drho_air(k)
+          ENDDO
+!
+!--       Urban-type surfaces, upward-facing
+          surf_s = surf_usm_h%start_index(j,i)
+          surf_e = surf_usm_h%end_index(j,i)
+          DO  m = surf_s, surf_e
+             k   = surf_usm_h%k(m)
+
+             tend(k,j,i) = tend(k,j,i) + s_flux_usm_h_up(m)                    &
+                                       * ddzw(k) * drho_air(k)
           ENDDO
        ENDIF
-
-!
-!--    Compute vertical diffusion. In case that surface fluxes have been
-!--    prescribed or computed at bottom and/or top, index k starts/ends at
-!--    nzb+2 or nzt-1, respectively.
-       DO  k = nzb_diff_s_inner(j,i), nzt_diff
-
-          tend(k,j,i) = tend(k,j,i)                                            &
-                                       + 0.5_wp * (                            &
-            ( kh(k,j,i) + kh(k+1,j,i) ) * ( s(k+1,j,i)-s(k,j,i) ) * ddzu(k+1)  &
-                                                            * rho_air_zw(k)    &
-          - ( kh(k,j,i) + kh(k-1,j,i) ) * ( s(k,j,i)-s(k-1,j,i) ) * ddzu(k)    &
-                                                            * rho_air_zw(k-1)  &
-                                                  ) * ddzw(k) * drho_air(k)
-       ENDDO
-
-!
-!--    Vertical diffusion at the first computational gridpoint along z-direction
-       IF ( use_surface_fluxes )  THEN
-
-          k = nzb_s_inner(j,i)+1
-
-          tend(k,j,i) = tend(k,j,i) + ( 0.5_wp * ( kh(k,j,i)+kh(k+1,j,i) )     &
-                                               * ( s(k+1,j,i)-s(k,j,i) )       &
-                                               * ddzu(k+1)                     &
-                                               * rho_air_zw(k)                 &
-                                        + s_flux_b(j,i)                        &
-                                      ) * ddzw(k) * drho_air(k)
-
-       ENDIF
-
 !
 !--    Vertical diffusion at the last computational gridpoint along z-direction
        IF ( use_top_fluxes )  THEN
-
-          k = nzt
-
-          tend(k,j,i) = tend(k,j,i) + ( - s_flux_t(j,i)                        &
-                                      - 0.5_wp * ( kh(k-1,j,i)+kh(k,j,i) )     &
-                                               * ( s(k,j,i)-s(k-1,j,i) )       &
-                                               * ddzu(k)                       &
-                                               * rho_air_zw(k-1)               &
-                                      ) * ddzw(k) * drho_air(k)
-
+          surf_s = surf_def_h(2)%start_index(j,i)
+          surf_e = surf_def_h(2)%end_index(j,i)
+          DO  m = surf_s, surf_e
+
+             k   = surf_def_h(2)%k(m)
+             tend(k,j,i) = tend(k,j,i)                                         &
+                           + ( - s_flux_t(m) ) * ddzw(k) * drho_air(k)
+          ENDDO
        ENDIF
 
